﻿/*

For use with Clinically Speaking Vocabulary project @ UTS.

written by:
Dave Kaplan
kaptron@gmail.com

*/

import mx.transitions.Tween;
import mx.transitions.easing.*;
import util.*;

class util.Playlist
{
	var event0r:Object;
	
	private var parent_mc:MovieClip;
	private var _mc:MovieClip;

	//column widths
	private var _c1w:Number;
	private var _c2w:Number;
	private var _c3w:Number;
	
	
	/*
	this.createTextField("my_txt", 1, 100, 100, 300, 100);
	my_txt.multiline = true;
	my_txt.wordWrap = false;
	var my_fmt:TextFormat = new TextFormat();
	my_fmt.color = 0xFF0000;
	my_fmt.underline = true;
	my_txt.text = "This is my first test field object text.";
	my_txt.setTextFormat(my_fmt);
	*/

	private var _fmt:TextFormat;
	private var _selectedfmt:TextFormat;
	private var _titlefmt:TextFormat;
	
	
	private var titlebar_mc:MovieClip;
	
	private var _rowh:Number;
	private var _xmargin:Number;
	private var _ymargin:Number;
	
	private var _colpadding:Number;
	
	private var _rows:Number;
	
	private var _list:Array;
	private var _scroll:Number;
	
	private var _sortOrder;
	private var _sortAsc;
	
	private var _playmode;
	
	private var _titlebarColor;
	private var _titlebarSelected;
	
	public function Playlist(parent_mc:MovieClip) {
		
		this.parent_mc = parent_mc;
		this._mc = parent_mc.createEmptyMovieClip("playlist_mc", parent_mc.getNextHighestDepth());
		
		this.event0r = {};
		AsBroadcaster.initialize(this.event0r);
		
		//event0r.addListener(this._mc);
		
		this._c1w = 425;
		this._c2w = 160;
		this._c3w = 250;
		
		this._rowh = 30;
		this._xmargin = 20;
		this._ymargin = 125;
		this._colpadding = 5;
		
		this._rows = 12;

		this._fmt = new TextFormat();
		this._fmt.color = 0x000066;
		this._fmt.font = "Arial";
		this._fmt.size = 14;
		
		this._selectedfmt = new TextFormat();
		this._selectedfmt.color = 0xFFFFFF;
		this._selectedfmt.font = "Arial";
		this._selectedfmt.size = 14;
	
		this._titlefmt = new TextFormat();
		this._titlefmt.color = 0x000000;
		this._titlefmt.font = "Arial";
		this._titlefmt.size = 20;
		
		this._list = null;
		this._scroll = 0;
		
		this._sortOrder = "word";
		this._sortAsc = true;
		
		this._playmode = "stopped";
		
		this._titlebarColor = 0xBEDCE2;
		this._titlebarSelected = 0x6795C2;
		
		this.mcInit();
		
	}
	
	private function mcInit() {
		
		var _playlist = this;

		
		this.titlebar_mc = this._mc.createEmptyMovieClip("titlebar", this._mc.getNextHighestDepth());
		
		this.titlebar_mc._x = this._xmargin;
		this.titlebar_mc._y = this._ymargin;
		
		var wordbtn = this.titlebar_mc.createEmptyMovieClip("wordbtn", this.titlebar_mc.getNextHighestDepth());
		wordbtn._x = -this._colpadding;
		drawRectangle(wordbtn, this._c1w, this._rowh, 0x000000, 0);
		drawRoundedRectangle(wordbtn, this._c1w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
		wordbtn.onPress = function() {
			_playlist.sortBy("word", true);
		}
		
		this.titlebar_mc.createTextField("word", this.titlebar_mc.getNextHighestDepth(), 0, 0, this._c1w, this._rowh);
		this.titlebar_mc.word.text = "Word";
		this.titlebar_mc.word.selectable = false;
		//this.titlebar_mc.word.border = true;
		this.titlebar_mc.word.setTextFormat(this._titlefmt);
		
		
		
		var catbtn = this.titlebar_mc.createEmptyMovieClip("catbtn", this.titlebar_mc.getNextHighestDepth());
		catbtn._x = this._c1w-this._colpadding;
		drawRectangle(catbtn, this._c2w, this._rowh, 0x000000, 0);
		drawRoundedRectangle(catbtn, this._c2w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
		
		catbtn.onPress = function() {
			_playlist.sortBy("category", true);
		}
		this.titlebar_mc.createTextField("category", this.titlebar_mc.getNextHighestDepth(), this._c1w, 0, this._c2w, this._rowh);
		this.titlebar_mc.category.setTextFormat(this._titlefmt);
		this.titlebar_mc.category.text = "Category";
		this.titlebar_mc.category.selectable = false;
		//this.titlebar_mc.category.border = true;
		this.titlebar_mc.category.setTextFormat(this._titlefmt);
		
		
		var subcatbtn = this.titlebar_mc.createEmptyMovieClip("subcatbtn", this.titlebar_mc.getNextHighestDepth());
		subcatbtn._x = this._c1w+this._c2w-this._colpadding;
		drawRectangle(subcatbtn, this._c3w, this._rowh, 0x000000, 0);
		drawRoundedRectangle(subcatbtn, this._c3w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
		subcatbtn.onPress = function() {
			_playlist.sortBy("subcategory", true);
		}
		this.titlebar_mc.createTextField("subcategory", this.titlebar_mc.getNextHighestDepth(), this._c1w+this._c2w, 0, this._c3w, this._rowh);
		this.titlebar_mc.subcategory.setTextFormat(this._titlefmt);
		this.titlebar_mc.subcategory.text = "Subcategory";
		this.titlebar_mc.subcategory.selectable = false;
		//this.titlebar_mc.subcategory.border = true;
		this.titlebar_mc.subcategory.setTextFormat(this._titlefmt);
		
		
		
		
		for (var i = 0; i < this._rows; i++) {
			var slot = this._mc.createEmptyMovieClip("slot"+i, this._mc.getNextHighestDepth());
			slot.id = i;
			slot._x = this._xmargin;
			slot._y = this._ymargin + this._rowh*(i+1);
			
			var slotbtn = slot.createEmptyMovieClip("slotbtn", slot.getNextHighestDepth());
			var slotrollover = slot.createEmptyMovieClip("slotrollover", slot.getNextHighestDepth());
			var slotselected = slot.createEmptyMovieClip("slotselected", slot.getNextHighestDepth());
			drawRectangle(slotbtn, this._c1w+this._c2w+this._c3w, this._rowh, 0x000000, 0);
			drawRoundedRectangle(slotrollover, this._c1w+this._c2w+this._c3w, this._rowh-5, 5, 0x2B4866, 100);
			drawRoundedRectangle(slotselected, this._c1w+this._c2w+this._c3w, this._rowh-5, 5, 0x73C5D9, 100);

			slotrollover._visible = false;
			slotselected._visible = false;

			slotbtn.onRollOver = function() {
				//this._parent == slot
				this._parent.slotrollover._visible = true;
				
				this._parent.word.setTextFormat(_playlist._selectedfmt);
				this._parent.category.setTextFormat(_playlist._selectedfmt);
				this._parent.subcategory.setTextFormat(_playlist._selectedfmt);
			}
			slotbtn.onRollOut = function() {
				this._parent.slotrollover._visible = false;
				
				this._parent.word.setTextFormat(_playlist._fmt);
				this._parent.category.setTextFormat(_playlist._fmt);
				this._parent.subcategory.setTextFormat(_playlist._fmt);
				
			}
			
			
			slotbtn.onReleaseOutside = function() {
				this._parent.slotrollover._visible = false;
				
				this._parent.word.setTextFormat(_playlist._fmt);
				this._parent.category.setTextFormat(_playlist._fmt);
				this._parent.subcategory.setTextFormat(_playlist._fmt);
				
			}
			
			
			slot.createTextField("word", slot.getNextHighestDepth(), 0, 0, this._c1w, this._rowh);
			slot.word.selectable = false;
			
			slot.createTextField("category", slot.getNextHighestDepth(), this._c1w, 0, this._c2w, this._rowh);
			slot.category.selectable = false;
			
			slot.createTextField("subcategory", slot.getNextHighestDepth(), this._c1w+this._c2w, 0, this._c3w, this._rowh);
			slot.subcategory.selectable = false;
			
			slot.selected = false;
			
			event0r.addListener(slot);	
			
			slot.unselect = function() {
				this.selected = false;
				this.slotselected._visible = false;
			}
			
			slot.hideCamIcons = function() {
				this.cameraIcon._visible = false;
			}
			
			var cameraIcon = slot.attachMovie("camera-icon", "cameraIcon", slot.getNextHighestDepth());
			cameraIcon._visible = false;
			
			var slotLoading = slot.createEmptyMovieClip("slotLoading", slot.getNextHighestDepth());
			drawRoundedRectangle(slotLoading, this._c1w+this._c2w+this._c3w, this._rowh-5, 5, 0xFF8080, 85);

			slotLoading.createTextField("txt", slot.getNextHighestDepth(), this._c1w/2, 0, this._c1w, this._rowh);
			slotLoading.txt.text = "Loading...";
			slotLoading.txt.selectable = false;
			
			slotLoading._visible = false;
			
			
		}
		
		var scrollbox_mc = this._mc.createEmptyMovieClip("scrollbox_mc", this._mc.getNextHighestDepth());
		scrollbox_mc._x = this._c1w+this._c2w+this._c3w+30;
		scrollbox_mc._y = this._ymargin+20;
			
		drawBox(scrollbox_mc, 15, this._rows*this._rowh-20, 0x000000, 100);
		fillBox(scrollbox_mc, 15, this._rows*this._rowh-20, 0xFFFFFF, 100);
		
		var scrollup_mc = this._mc.createEmptyMovieClip("scrollup_mc", this._mc.getNextHighestDepth());
		drawTriangle(scrollup_mc, 14, 0x569AA0, 100);
		scrollup_mc._x = scrollbox_mc._x+1;
		scrollup_mc._y = this._ymargin;
		var upbtn = scrollup_mc.createEmptyMovieClip("upbtn", scrollup_mc.getNextHighestDepth());
		drawRectangle(upbtn, 14, 12, 0xFFFFFF, 0);
		
		var scrolldown_mc = this._mc.createEmptyMovieClip("scrolldown_mc", this._mc.getNextHighestDepth());
		drawTriangle(scrolldown_mc, 14, 0x569AA0, 100);
		scrolldown_mc._x = scrollbox_mc._x+1;
		scrolldown_mc._y = this._ymargin+scrollbox_mc._height+40;
		scrolldown_mc._yscale = -100;
		var downbtn = scrolldown_mc.createEmptyMovieClip("downbtn", scrolldown_mc.getNextHighestDepth());
		drawRectangle(downbtn, 14, 14, 0xFFFFFF, 0);
		
		//var scroller_mc = this._mc.createEmptyMovieClip("scroller_mc", this._mc.getNextHighestDepth());
		
		
		////////////////////
		//var imagewindow = this._mc.attachMovie("imagewindow", "imagewindow", this._mc.getNextHighestDepth());
		var imagewindow = this._mc.createEmptyMovieClip("imagewindow", this._mc.getNextHighestDepth());
		var dropshad = imagewindow.createEmptyMovieClip("dropshad", imagewindow.getNextHighestDepth());
		var frame = imagewindow.createEmptyMovieClip("frame", imagewindow.getNextHighestDepth());
		var dummy = imagewindow.attachMovie("dummy", "dummy", imagewindow.getNextHighestDepth());
		var close_btn = imagewindow.attachMovie("close_btn", "close", imagewindow.getNextHighestDepth());
		
		var i_width = this._c2w + this._c3w;
		var i_height = this._rowh * (this._rows+1);
		
		var i_xratio = i_width/410;
		var i_yratio = this._rows/16;
		
		fillBox(dropshad, i_width, i_height, 0xaaaaaa, 70);
		dropshad._x = -5;
		dropshad._y = 7;
		
		drawBox(frame, i_width, i_height, 0x000000, 100);
		fillBox(frame, i_width, i_height, 0xffffff, 100);

		dummy._width = frame._width;
		dummy._height = frame._height;
		dummy._alpha = 0;
		
		close_btn._xscale = 40;
		close_btn._x = frame._width - 25;
		close_btn._y = 20;
				
		imagewindow._x = this._c1w + this._xmargin;
		imagewindow._y = this._ymargin;
		

		imagewindow.y = imagewindow._y;
		imagewindow.x = imagewindow._x;
		imagewindow._visible = false;
		
		imagewindow.createEmptyMovieClip("container", imagewindow.getNextHighestDepth());
		imagewindow.container._x = 20;
		imagewindow.container._y = 55;
		imagewindow.container._xscale = imagewindow.container._yscale = 100*(Math.min(i_xratio, i_yratio));
		
		var loader = imagewindow.attachMovie("loader", "loader", imagewindow.getNextHighestDepth());
		loader._x = 155;
		loader._y = 200;
		loader._xscale = 75;
		loader._yscale = 75;		
		loader._visible = false;
		
			imagewindow.imageLoader = new MovieClipLoader();


			// Create listener object:
			var mclListener:Object = new Object();
			mclListener.onLoadError = function(target_mc:MovieClip, errorCode:String, status:Number) {
				//trace("Error loading image: " + errorCode + " [" + status + "]");
			};
			mclListener.onLoadStart = function(target_mc:MovieClip):Void {
				//trace("onLoadStart: " + target_mc);
				//display spinning loader
				loader.gotoAndPlay(1);
				loader._visible = true;
			};
			mclListener.onLoadProgress = function(target_mc:MovieClip, numBytesLoaded:Number, numBytesTotal:Number):Void {
				var numPercentLoaded:Number = numBytesLoaded / numBytesTotal * 100;
				//trace("onLoadProgress: " + target_mc + " is " + numPercentLoaded + "% loaded");
			};
			mclListener.onLoadComplete = function(target_mc:MovieClip, status:Number):Void {
				//trace("onLoadComplete: " + target_mc);
				//hide loader
				loader._visible = false;
				
			};
			
			mclListener.onLoadInit = function(target_mc:MovieClip):Void {
				//
			}

			imagewindow.imageLoader.addListener(mclListener);
			

		imagewindow.dummy.useHandCursor = false;
		///////////////////
		
		//help screen
		
		var helpwindow = this._mc.createEmptyMovieClip("helpwindow", this._mc.getNextHighestDepth());
		var hframe = helpwindow.createEmptyMovieClip("frame", helpwindow.getNextHighestDepth());
		var hclose_btn = helpwindow.attachMovie("close_btn", "close", helpwindow.getNextHighestDepth());
		
		var h_width = this._c1w + this._c2w + this._c3w + 30;
		var h_height = this._rowh * (this._rows+1) + this._ymargin-25;
		
		helpwindow._x = this._xmargin;
		helpwindow._y = 25;

		fillBox(hframe, h_width, h_height, 0xE6FFFC, 100);
		
		hclose_btn._xscale = 40;
		hclose_btn._x = hframe._width - 25;
		hclose_btn._y = 20;

		hclose_btn.onPress = function() {
			_playlist._mc.scroller_mc._visible = true;
			_playlist._mc.helpwindow._visible = false;
		}
		
		/**
		 Requires:
		  - UIScrollBar component in library
		*/
		// Create text field.
		var helptxt = helpwindow.createTextField("helptxt", helpwindow.getNextHighestDepth(), 40, 50, h_width-100, h_height-100);
		helptxt.wordWrap = true;
		helptxt.html = true;
		helptxt.selectable = false;
		helptxt.setNewTextFormat(this._fmt);
		
		var help_sb = helpwindow.createClassObject(mx.controls.UIScrollBar, "help_sb", 20);
		
		// Set the target text field for the scroll bar.
		help_sb.setScrollTarget(helptxt);
		
		// Size it to match the text field.
		help_sb.setSize(16, helptxt._height); 
		
		// Move it next to the text field.
		help_sb.move(helptxt._x + helptxt._width+20, helptxt._y);
		
		// Load text to display and define onData handler.
		var help_lv:LoadVars = new LoadVars();
		help_lv.onData = function(src:String) {
			if (src != undefined) {
				helptxt.htmlText = src;
			} else {
				helptxt.htmlText = "Error loading text.";
			}
		};
		//help_lv.load("http://www.helpexamples.com/flash/lorem.txt");
		help_lv.load("text/help.txt");
		
		helpwindow._visible = false;
		
		
	}
	
	
	private function drawArrow() {

		var wordbtn = this.titlebar_mc.wordbtn;
		var catbtn = this.titlebar_mc.catbtn;
		var subcatbtn = this.titlebar_mc.subcatbtn;
		
		this.titlebar_mc.arrow.removeMovieClip();
		delete this.titlebar_mc.arrow;
		
		var arrow = this.titlebar_mc.createEmptyMovieClip("arrow", this.titlebar_mc.getNextHighestDepth());
		drawTriangle(arrow, 15, 0x000000, 66);
		arrow._x = -35;
		
		if (this._sortAsc) {
			arrow._y = 6;
		} else {
			arrow._yscale = -100;
			arrow._y = 20;
		}
		
		if (this._sortOrder == "word") {
			//arrow._x += this.titlebar_mc.word.textWidth;
			arrow._x += this._c1w;
			
			drawRoundedRectangle(catbtn, this._c2w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
			drawRoundedRectangle(subcatbtn, this._c3w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
			
			drawRoundedRectangle(wordbtn, this._c1w-this._colpadding, this._rowh, 5, this._titlebarSelected, 100);
			
			
		} else if (this._sortOrder == "category") {
			arrow._x += this._c1w+this._c2w;
			//arrow._x += this.titlebar_mc.category.textWidth;
			
			var catbtn = this.titlebar_mc.catbtn;
			
			drawRoundedRectangle(wordbtn, this._c1w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
			drawRoundedRectangle(subcatbtn, this._c3w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
			
			drawRoundedRectangle(catbtn, this._c2w-this._colpadding, this._rowh, 5, this._titlebarSelected, 100);
			
		} else if (this._sortOrder == "subcategory") {
			arrow._x += this._c1w+this._c2w+this._c3w;
			//arrow._x += this.titlebar_mc.subcategory.textWidth;
			
			drawRoundedRectangle(wordbtn, this._c1w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
			drawRoundedRectangle(catbtn, this._c2w-this._colpadding, this._rowh, 5, this._titlebarColor, 100);
			
			drawRoundedRectangle(subcatbtn, this._c3w-this._colpadding, this._rowh, 5, this._titlebarSelected, 100);
			
		}
		
	}
	
	
	public function traceMC() {
		
		trace(this._mc);
		
	}
	
	public function changeFontSize(n) {
		this._selectedfmt.size = n;
		this._fmt.size = n;
		
	}
	
	public function sortAndDisplayWords(list:Array) {
		
		this._list = list;
		sortBy(this._sortOrder, false);
		//trace(this._sortOrder);
		//displayWords(list);
		
	}
	

	//list should be an array of word objects, each with .txt, .snd, .img, .tag...
	private function displayWords() {
				
		displayFunc(0);
		
		if (_list.length > this._rows) {
			enableScroll();
		} else {
			disableScroll();
		}
		
	}
	
	
	//handles displaying for displayWords() and redisplayWords()
	//-scroll is scroll offset (used with redisplayWords)
	//-sets up the buttons to play sounds, show imgs
	//-sets up reset function to set things back to normal
	
	function displayFunc(scroll:Number) {
		
		event0r.broadcastMessage("unselect");
		event0r.broadcastMessage("hideCamIcons");
		
		var n = Math.min(_list.length, this._rows);
		var _rows = this._rows;
		
		for (var i = 0; i < n; i++) {
			var wordObj = _list[i+scroll];
			var slot = this._mc["slot"+i];
			
			slot.word.txtonly = wordObj.txt.data;
			slot.word.text = wordObj.txt.data;
			if (wordObj.ortxt.data) {
				slot.word.text += " or "+ wordObj.ortxt.data;
			}
			slot.word.setTextFormat(this._fmt);
		
			slot.category.text = wordObj.category;
			slot.category.setTextFormat(this._fmt);
			
			slot.subcategory.text = wordObj.tag.data;
			slot.subcategory.setTextFormat(this._fmt);
			
			slot.slotLoading.txt.setTextFormat(this._fmt);

			slot.slotbtn._visible = true;			
			slot.slotbtn.snd = wordObj.snd.data;
			slot.slotbtn.img = wordObj.img.data;

			slot.playbtn = function() {
				if (this.selected) {
					this.slotbtn.onPress();
				}
			}
			
			if (slot.slotbtn.img) {
				slot.cameraIcon._visible = true;
				slot.cameraIcon._x = slot.word.textWidth+10;
			} else {
				slot.cameraIcon._visible = false;
			}
			
			slot.slotbtn.onPress = function() {
				
				///TURN PLAY MODE ON
				///=================
				
				///????????
				
		
				stopAllSounds();
				
				
				var playlist_mc = this._parent._parent;	
				var playlist = playlist_mc._parent._parent.playlist;
				var event0r = playlist_mc._parent._parent.playlist.event0r;
				
				var slot = this._parent;
				
								
				//unselects other selected items by unselecting ALL ... (bad?)				
				event0r.broadcastMessage("unselect");
				
				//resets (hides) the imagewindow
				playlist_mc.reset();
				
				//set this slot to 'selected'
				slot.selected = true;
				
				//give this slot the selection highlight
				slot.slotselected._visible = true;
				
				var nextid = this._parent.id + 1;
				var id = this._parent.id;
				
				var my_sound:Sound = new Sound();
				
				//eg set folder to "cardiovascular/"
				var folder = slot.category.text.toLowerCase() + "/";
				
				my_sound.onSoundComplete = function() {
					if (playlist.playmode() == "continuous") {
						playlist.clickNextSlot();
					}
				}

				//if there is a <snd> defined in the xml...
				if (this.snd) {
		
					var sndfile = this.snd.toLowerCase();
					
					/*
					my_sound.onLoad = function(success:Boolean) {
						if (success) {
							my_sound.start();
						}
					}
					*/
					
					my_sound.loadSound("sounds/" + folder + sndfile, false);
					
					////////////////////////////////
					//fix for stupid IE sound loading bug ???
					/////////////
					var checkSoundLoaded = function() {
						  if(my_sound.getBytesTotal() != undefined){
							  if(my_sound.getBytesLoaded() >= my_sound.getBytesTotal()) {
  								  slot.slotLoading._visible = false;
								  my_sound.start();
								  clearInterval(intervalID);
							  } else {
								  slot.slotLoading._visible = true;
								  //var loaded = my_sound.getBytesLoaded() / my_sound.getBytesTotal();
								  //trace ("LOADING SOUND %: " + loaded);
								  
							  }
						  }
					 }
					 var intervalID = setInterval(checkSoundLoaded, 200);
					
					
				//else, assume there must be a xxxxx.mp3 where "xxxxx" is the word
				} else {
					
					var sndfile = slot.word.txtonly.toLowerCase();
					
					/*
					my_sound.onLoad = function(success:Boolean) {
						if (success) {
							my_sound.start();
						}
					}
					*/
					
					my_sound.loadSound("sounds/" + folder + sndfile + ".mp3", false);
					
					var checkSoundLoaded = function() {
						  if(my_sound.getBytesTotal() != undefined){
							  if(my_sound.getBytesLoaded() >= my_sound.getBytesTotal()) {
  								  slot.slotLoading._visible = false;								  
								  my_sound.start();
								  clearInterval(intervalID);
							  } else {
  								  slot.slotLoading._visible = true;
								  //var loaded = my_sound.getBytesLoaded() / my_sound.getBytesTotal();
								  //trace ("LOADING SOUND %: " + loaded);
								  
							  }
						  }
					 }
					 var intervalID = setInterval(checkSoundLoaded, 200);
					
					
				}
				
				
				if (this.img) {
					
					var imagewindow = playlist_mc.imagewindow;
					var helpwindow = playlist_mc.helpwindow;
					var imageLoader = imagewindow.imageLoader;
					var container = imagewindow.container;
					imagewindow._visible = true;
					imagewindow._xscale = 10;
					imagewindow._yscale = 10;
					imagewindow._y = slot._y;
					imagewindow._x = imagewindow.x - 225;
					
					//imagewindow.container.loadMovie("images/" + this.img);
					
					//TEST
					var imgfile = this.img.toLowerCase();
										
					//using loadClip instead of loadMovie, can monitor download progress					
					imageLoader.loadClip("images/" + folder + imgfile, container);
					//imagewindow.container.loadMovie("images/resized/" + imgfile);
										
					var moveTween:EasyTween = new EasyTween(imagewindow, "moveTween", [imagewindow.x, imagewindow.y, 0], 12,  Regular.easeOut);
					var scaleTween:EasyTween = new EasyTween(imagewindow, "scaleTween", [100, 100], 12,  Regular.easeOut);
								
			
					imagewindow.close.onPress = function() {
						playlist_mc.reset();
						
					}
					
					//RESET IS JUST FOR CLEARING THE IMAGE WINDOW
					playlist_mc.reset = function() {
						//playlist_mc.imagewindow.gotoAndStop("normal");
						playlist_mc.imagewindow._visible = false;
						
						this.reset = null;
					}
					
					
					/*
					//get _rows/2, figure out if it should go up or down
					if (nextid < _rows/2) {
						
					} else {
												
					}
					*/
					
				} else {
					
					//playlist_mc.reset = function() {
						//stopAllSounds...
					//}
					
				}
				
				
				
				
			}

			
		}

		for (var i = n; i < this._rows; i++) {
			var slot = this._mc["slot"+i];
			slot.slotbtn._visible = false;

		}

	}
	
	
	public function playmode():String {
		return this._playmode;
	}
	
	public function setPlaymode(str:String) {
		this._playmode = str;
	}
	
	//find if any slot is currently selected (clicked on)
	public function findSelected():Number {
		var n:Number = -1
		
		for (var i = 0; i < this._rows; i++) {
			var slot = this._mc["slot"+i];
			if (slot.selected) n = i;
		}
		
		return n;
	}
	
	
	//click the first slot
	public function clickSlot(n:Number) {
		var slot = this._mc["slot"+n];
		slot.slotbtn.onPress();
	}
	
	public function clickCurrentSlot() {
		var selected = findSelected();
		
		//if none are selected
		if (selected == -1) {
			clickSlot(0);
		} else {
			clickSlot(selected);
		}
	}
		
	//click the next slot (after selected one)
	public function clickNextSlot() {
		
		var n = Math.min(_list.length, this._rows);

		var selected = findSelected();
		
		//if none are selected
		if (selected == -1) {
			clickSlot(0);
			
		//if selected is not the last row, click the next one	
		} else if (selected < n-1) {
			var slot = this._mc["slot"+(selected+1)];
			slot.slotbtn.onPress();
		//if selected is the last row
		} else if (selected == n-1) {
			//if we're on the last item, check how many remain on the list
			var remain = this._list.length - (this._scroll+this._rows);
			
			var scroller_mc = this._mc.scroller_mc;
			
			//if we've got a full page worth, move down the whole page
			if (remain >= this._rows) {
				var diff = this._list.length - this._rows;
				this._scroll += this._rows;
				
				var dist = this._scroll/diff;
				scroller_mc._y = (dist*(scroller_mc._maxy - scroller_mc._miny)) + scroller_mc._miny;
				
				//var dist = (scroller_mc._y - scroller_mc._miny)/(scroller_mc._maxy - scroller_mc._miny);
				//var scroll = dist*diff;
				
				redisplayWords();
				clickSlot(0);
				
			//otherwise.....
			} else if (remain > 0) {
				scroller_mc._y = scroller_mc._maxy;
				var diff = this._list.length - this._rows;
				var dist = (scroller_mc._y - scroller_mc._miny)/(scroller_mc._maxy - scroller_mc._miny);
				var scroll = Math.round(dist*diff);				
				//see how many slots distance we are moving
				var d = scroll - this._scroll
				this.checkScroll(scroll);
				
				//slots have moved, but still want to click the next word in sequence
				clickSlot(this._rows-d);
				
			} else {
				//just click the same ol' one again
				//clickSlot(selected);
				setPlaymode("stopped");
				this._mc._parent._parent.play_btn.gotoAndStop("play");
				
			}
		}
	
	}
	
	
	private function redisplayWords() {
		
		displayFunc(this._scroll);
		
	}
	
	
	private function enableScroll() {
		var _playlist = this;
		
		//var scroller_mc = this._mc.createEmptyMovieClip("scroller_mc", this._mc.getNextHighestDepth());
		var scroller_mc = this._mc.attachMovie("scroller", "scroller_mc", this._mc.getNextHighestDepth());
		
		scroller_mc._x = this._c1w+this._c2w+this._c3w+32;
		
		//+20 to make room for scroll arrows
		scroller_mc._y = _playlist._ymargin+20;
		scroller_mc._miny = _playlist._ymargin+20;
		scroller_mc._maxy = _playlist._rows*_playlist._rowh+_playlist._ymargin-30;
		
		//drawRoundedRectangle(scroller_mc, 12, 30, 5, 0x263F48, 100);
		
		var diff = this._list.length - this._rows;
		
		
		var scrollbox_mc = _playlist._mc.scrollbox_mc;
		
		scrollbox_mc.onPress = function() {
			var y = _ymouse-10;
			
			if (y < scroller_mc._miny) y = scroller_mc._miny;
			if (y > scroller_mc._maxy) y = scroller_mc._maxy;
			
			scroller_mc._y = y;
			
			var dist = (scroller_mc._y - scroller_mc._miny)/(scroller_mc._maxy - scroller_mc._miny);
				
			var scroll = Math.round(dist*diff);
				
			if (scroll)	_playlist.checkScroll(scroll);
			
		}
		
		var upbtn = _playlist._mc.scrollup_mc.upbtn;
		
		upbtn.onPress = function() {
			_playlist._mc.reset();
			
			this.onEnterFrame = function() {
				var diff = _playlist._list.length - _playlist._rows;
				var scroller_mc = _playlist._mc.scroller_mc;
				
				//one 'unit' of scrollbar movement
				var unit = Math.floor((scroller_mc._maxy - scroller_mc._miny)/diff);
				
				if (unit && (scroller_mc._y-unit >= scroller_mc._miny)) {
					scroller_mc._y = scroller_mc._y-unit;
					//scroller_mc.y += 10;
				
					var dist = (scroller_mc._y - scroller_mc._miny)/(scroller_mc._maxy - scroller_mc._miny);
					var scroll = Math.round(dist*diff);
					
					/* we want: 
					1 = dist*diff;
					
					1/diff = dist;
					1/diff = (scroller_mc.y - scroller_mc._miny)
					(scroller_mc._maxy - scroller_mc._miny)/diff = scroller_mc.y - scroller_mc._miny
					scroller_mc._miny + (scroller_mc._maxy - scroller_mc._miny)/diff = scroller_mc.y
					*/
			
					_playlist.checkScroll(scroll);
				
				//special case for reaching the top of the list
				} else if (scroller_mc._y-unit < scroller_mc._miny) {
									
					scroller_mc._y = scroller_mc._miny;
					var dist = (scroller_mc._y - scroller_mc._miny)/(scroller_mc._maxy - scroller_mc._miny);
					var scroll = Math.round(dist*diff);
					_playlist.checkScroll(scroll);
					
				}
			}
		}
		
		upbtn.onRelease = function() {
			delete this.onEnterFrame;
		}
		upbtn.onReleaseOutside = function() {
			delete this.onEnterFrame;
		}
		var downbtn = _playlist._mc.scrolldown_mc.downbtn;
		
		downbtn.onPress = function() {
			_playlist._mc.reset();
			
			this.onEnterFrame = function() {
				var diff = _playlist._list.length - _playlist._rows;
				var scroller_mc = _playlist._mc.scroller_mc;

				//one 'unit' of scrollbar movement
				var unit = Math.floor((scroller_mc._maxy - scroller_mc._miny)/diff);
				
				if (unit && (scroller_mc._y+unit <= scroller_mc._maxy)) {
					scroller_mc._y = scroller_mc._y+unit;
					//scroller_mc.y += 10;
				
					var dist = (scroller_mc._y - scroller_mc._miny)/(scroller_mc._maxy - scroller_mc._miny);
					var scroll = Math.round(dist*diff);
					
					/* we want: 
					1 = dist*diff;
					
					1/diff = dist;
					1/diff = (scroller_mc.y - scroller_mc._miny)
					(scroller_mc._maxy - scroller_mc._miny)/diff = scroller_mc.y - scroller_mc._miny
					scroller_mc._miny + (scroller_mc._maxy - scroller_mc._miny)/diff = scroller_mc.y
					*/
					
			
					_playlist.checkScroll(scroll);
					
				//special case for reaching the bottom of the list	
				} else if (scroller_mc._y+unit > scroller_mc._maxy) {
									
					scroller_mc._y = scroller_mc._maxy;
					var dist = (scroller_mc._y - scroller_mc._miny)/(scroller_mc._maxy - scroller_mc._miny);
					var scroll = Math.round(dist*diff);
					_playlist.checkScroll(scroll);
					
				}
    		}
	
		}
		
		downbtn.onRelease = function() {
			delete this.onEnterFrame;
		}
		downbtn.onReleaseOutside = function() {
			delete this.onEnterFrame;
		}
		
		scroller_mc.onPress = function() {
			_playlist._mc.reset();
			
			startDrag(scroller_mc, false, scroller_mc._x, scroller_mc._miny, scroller_mc._x, scroller_mc._maxy);
			
			scroller_mc.onEnterFrame = function() {
				var dist = (this._y - this._miny)/(this._maxy - this._miny);
				
				var scroll = Math.round(dist*diff);
				
				_playlist.checkScroll(scroll);
				
			}
		}
		
		scroller_mc.onRelease = function() {
			scroller_mc.onEnterFrame = null;
			stopDrag();
		}
		scroller_mc.onReleaseOutside = function() {
			scroller_mc.onEnterFrame = null;
			stopDrag();
		}
			
	}
	
	private function checkScroll(n:Number) {
		//trace("checking");
		if (this._scroll != n) {
			this._scroll = n;
			//clearWords();
			redisplayWords();
			
		} else {
			//trace("all good in the hood");
		}
		
	}
	
	
	private function disableScroll() {
		var scroller_mc = this._mc["scroller_mc"];
		scroller_mc.onEnterFrame = null;
		scroller_mc.removeMovieClip();
		delete scroller_mc;
	}
	
	
	
	function drawRectangle(target_mc:MovieClip, boxWidth:Number, boxHeight:Number, fillColor:Number, fillAlpha:Number):Void {
		with (target_mc) {
			beginFill(fillColor, fillAlpha);
			moveTo(0, 0);
			lineTo(boxWidth, 0);
			lineTo(boxWidth, boxHeight);
			lineTo(0, boxHeight);
			lineTo(0, 0);
			endFill();
		}
	}

	
	function drawRoundedRectangle(target_mc:MovieClip, boxWidth:Number, boxHeight:Number, cornerRadius:Number, fillColor:Number, fillAlpha:Number):Void {
			with (target_mc) {
				beginFill(fillColor, fillAlpha);
				moveTo(cornerRadius, 0);
				lineTo(boxWidth - cornerRadius, 0);
				curveTo(boxWidth, 0, boxWidth, cornerRadius);
				lineTo(boxWidth, cornerRadius);
				lineTo(boxWidth, boxHeight - cornerRadius);
				curveTo(boxWidth, boxHeight, boxWidth - cornerRadius, boxHeight);
				lineTo(boxWidth - cornerRadius, boxHeight);
				lineTo(cornerRadius, boxHeight);
				curveTo(0, boxHeight, 0, boxHeight - cornerRadius);
				lineTo(0, boxHeight - cornerRadius);
				lineTo(0, cornerRadius);
				curveTo(0, 0, cornerRadius, 0);
				lineTo(cornerRadius, 0);
				endFill();
			}
	}
	

	function drawBox(target_mc:MovieClip, boxWidth:Number, boxHeight:Number, fillColor:Number, fillAlpha:Number):Void {
		with (target_mc) {
			lineStyle(1, 0x000000, 100);
			moveTo(0, 0);
			lineTo(boxWidth, 0);
			lineTo(boxWidth, boxHeight);
			lineTo(0, boxHeight);
			lineTo(0, 0);
		}
	}
	
	function fillBox(target_mc:MovieClip, boxWidth:Number, boxHeight:Number, fillColor:Number, fillAlpha:Number):Void {
		with (target_mc) {
			beginFill(fillColor, fillAlpha);
			//lineStyle(1, 0x000000, 100);
			moveTo(0, 0);
			lineTo(boxWidth, 0);
			lineTo(boxWidth, boxHeight);
			lineTo(0, boxHeight);
			lineTo(0, 0);
			endFill();
		}
	}

	function drawTriangle(target_mc:MovieClip, sideLength:Number, fillColor:Number, fillAlpha:Number):Void {
		var tHeight:Number = sideLength * Math.sqrt(3) / 2;
		with (target_mc) {
			beginFill(fillColor, fillAlpha);
			moveTo(sideLength / 2, 0);
			lineTo(sideLength, tHeight);
			lineTo(0, tHeight);
			lineTo(sideLength / 2, 0);
			endFill();
		}
	}

	
	public function clearWords() {
		this._list = null;
		disableScroll();
		
		for (var i = 0; i < this._rows; i++) {
			
			var slot = this._mc["slot"+i];
			
			slot.word.text = "";
			slot.word.setTextFormat(this._fmt);
			
			slot.category.text = "";
			slot.category.setTextFormat(this._fmt);
			
			slot.subcategory.text = "";
			slot.subcategory.setTextFormat(this._fmt);

			
		}
		
	}
	
	
	private function sortBy(arg:String, flip:Boolean) {
		
		//templist[0].txt.data
		//templist[0].tag.data
		//templist[0].category
		
		this._mc.reset();
		
		
		var templist = this._list;
		
		//if we are clicking the same button again, flip the mofo
		if (arg == this._sortOrder && flip) {
			this._sortAsc = !this._sortAsc;
		} else if (arg != this._sortOrder) {
			this._sortAsc = true;
		}
		
		if (arg == "word") {
			if (!this._sortAsc) {
				templist = templist.sortOn("wordtext", Array.CASEINSENSITIVE | Array.DESCENDING);
			} else {
				templist = templist.sortOn("wordtext", Array.CASEINSENSITIVE);
			}
			this._sortOrder = "word";
			
		} else if (arg == "category") {
			if (!this._sortAsc) {
				templist = templist.sortOn(["category", "wordtext"], Array.CASEINSENSITIVE | Array.DESCENDING);
			} else {
				templist = templist.sortOn(["category", "wordtext"], Array.CASEINSENSITIVE);
			}
			
			
			this._sortOrder = "category";

		} else if (arg == "subcategory") {
			if (!this._sortAsc) {
				templist = templist.sortOn(["subcategory", "wordtext"], Array.CASEINSENSITIVE | Array.DESCENDING);
			} else {
				templist = templist.sortOn(["subcategory", "wordtext"], Array.CASEINSENSITIVE);
			}
			this._sortOrder = "subcategory";

		}
		
		drawArrow();
		clearWords();
		this._list = templist;
		displayWords();
		
	}
	
	
	public function resize(w:Number, h:Number) {
		
		var mc:MovieClip;
		for (var mc in this._mc) {
			mc.removeMovieClip();
			delete mc;
		}
		
		this._mc.removeMovieClip();
		delete this._mc;
		this._mc = this.parent_mc.createEmptyMovieClip("playlist_mc", parent_mc.getNextHighestDepth());

		//92.8% of total w
		
		//425 --51%
		//160 --19%
		//250 --30%
		
		var cWidth = Math.floor(.92778 * w);
		var rHeight = h - this._ymargin;
		var rows = Math.floor(rHeight/this._rowh);
		
		rows = Math.max(3, (rows-1));
				

		if (cWidth <= 700) {
			this._c1w = 357;
			this._c2w = 133;
			this._c3w = 210;
		} else {
			this._c1w = Math.floor(0.51*cWidth);
			this._c2w = Math.floor(0.19*cWidth);
			this._c3w = Math.floor(0.30*cWidth);
		}
		
		this._rows = rows;
		
		if ((rows > 15) && (cWidth > 770)) {
			changeFontSize(16);
		} else {
			changeFontSize(14);
		}
		
		//stop all sounds??
		this.mcInit();
		sortBy(this._sortOrder, false);
		
	}
	
			
}

