﻿class util.Sound2 extends Sound {
	//var to hold interval
	private var fade;  
	private var vol;
	private var max;
	
	static var global:Sound;
	
	public function Sound2(target:MovieClip) {
		super(target);
		this.fade = 0;
		this.vol = 0;
		this.max = 100;
	}
	
	public function setMax(n:Number) {
		this.max = n;
	}
	
	static function setGlobal(snd:Sound) {
		global = snd;
	}
	
	public function loopOn() {
		this.onSoundComplete = function () {
 		   this.start();
		}
	}
	
	public function loopOff() {
		this.onSoundComplete = null;
	}
	
	public function fadeIn(offset) {
		var off = 0;
		var interv = 100;
		if (offset) {
			off = offset;
			interv = 30;
		}
		this.vol = 0;
		this.setVolume(0);
		this.start(off, 0);
		this.fade = setInterval(fadeInSub, interv, this);
	}

	
	//subroutine for fadein
	private function fadeInSub(snd:Sound2) {
		if (global.getVolume() == 0) {
			snd.setVolume(0);
			clearInterval(snd.fade);
		} else {
		
			
			// fade the sound in with an increment of 3 in the variable 'vol'
			snd.vol += (snd.max/33);
			snd.setVolume(snd.vol);
			// put an if condition to restrict the increment in volume after it reaches 100
			if (snd.vol>=snd.max) {
				clearInterval(snd.fade);
			}
			
		}
	}
	
	public function fadeOut() {
		this.vol = this.getVolume();
		this.fade = setInterval(fadeOutSub, 100, this);
	}
	
	public function fadeOutFast() {
		this.vol = this.getVolume();
		this.fade = setInterval(fadeOutSub, 33, this);
	}
	
	//subroutine for fadeout
	private function fadeOutSub(snd:Sound2) {
		if (global.getVolume() == 0) {
			snd.setVolume(0);
			clearInterval(snd.fade);
		} else {
			// fade the sound out with an increment of 3 in the variable 'vol'
			snd.vol -= 3;
			snd.setVolume(snd.vol);
			// put an if condition to restrict the increment in volume after it reaches 0
			if (snd.vol<=0) {
				clearInterval(snd.fade);
				snd.stop();
			}
		}
	}
	
	
	
}